-- MySQL Script generated by MySQL Workbench
-- sex 12 out 2018 03:27:30 -03
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `mydb` DEFAULT CHARACTER SET utf8 ;
USE `mydb` ;

-- -----------------------------------------------------
-- Table `mydb`.`Login`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Login` (
  `username` VARCHAR(45) NOT NULL,
  `dbService` ENUM('GITHUB') NOT NULL,
  `password` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`username`, `dbService`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Project`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Project` (
  `name` VARCHAR(45) NOT NULL,
  `owner` VARCHAR(45) NOT NULL,
  `loginUsername` VARCHAR(45) NULL,
  `dbService` ENUM('GITHUB') NULL,
  `relevant` TINYINT(1) NULL,
  `state` ENUM('IDLE', 'SYNCING', 'FAILED', 'SUCCEEDED') NOT NULL DEFAULT 'IDLE',
  PRIMARY KEY (`name`, `owner`),
  INDEX `fk_Project_Login1_idx` (`loginUsername` ASC, `dbService` ASC),
  CONSTRAINT `fk_Project_Login1`
    FOREIGN KEY (`loginUsername` , `dbService`)
    REFERENCES `mydb`.`Login` (`username` , `dbService`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`ProjectItemModification`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`ProjectItemModification` (
  `id` INT NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`ProjectItem`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`ProjectItem` (
  `id` VARCHAR(45) NOT NULL,
  `projectName` VARCHAR(45) NOT NULL,
  `projectOwner` VARCHAR(45) NOT NULL,
  `type` ENUM('COMMIT', 'ISSUE', 'PULL_REQUEST', 'FILE') NOT NULL,
  `projectItemModificationId` INT NOT NULL,
  `createdAt` DATE NOT NULL,
  `text` VARCHAR(1024) NOT NULL,
  `author` VARCHAR(45) NOT NULL,
  `relevant` TINYINT(1) NULL,
  PRIMARY KEY (`id`, `projectName`, `projectOwner`),
  INDEX `fk_ProjectItem_ProjectItemModification1_idx` (`projectItemModificationId` ASC),
  INDEX `fk_ProjectItem_Project1_idx` (`projectName` ASC, `projectOwner` ASC),
  CONSTRAINT `fk_ProjectItem_ProjectItemModification1`
    FOREIGN KEY (`projectItemModificationId`)
    REFERENCES `mydb`.`ProjectItemModification` (`id`)
    ON DELETE CASCADE
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ProjectItem_Project1`
    FOREIGN KEY (`projectName` , `projectOwner`)
    REFERENCES `mydb`.`Project` (`name` , `owner`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`ProjectItemComment`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`ProjectItemComment` (
  `id` VARCHAR(45) NOT NULL,
  `projectItemId` VARCHAR(45) NOT NULL,
  `projectName` VARCHAR(45) NOT NULL,
  `projectOwner` VARCHAR(45) NOT NULL,
  `text` VARCHAR(1024) NOT NULL,
  `relevant` TINYINT(1) NULL,
  `createdAt` DATE NOT NULL,
  `author` VARCHAR(45) NOT NULL,
  `projectItemModificationId` INT NOT NULL,
  PRIMARY KEY (`id`, `projectItemId`, `projectName`, `projectOwner`),
  INDEX `fk_ProjectItemComment_ProjectItem1_idx` (`projectItemId` ASC, `projectName` ASC, `projectOwner` ASC),
  INDEX `fk_ProjectItemComment_ProjectItemModification1_idx` (`projectItemModificationId` ASC),
  CONSTRAINT `fk_ProjectItemComment_ProjectItem1`
    FOREIGN KEY (`projectItemId` , `projectName` , `projectOwner`)
    REFERENCES `mydb`.`ProjectItem` (`id` , `projectName` , `projectOwner`)
    ON DELETE CASCADE
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ProjectItemComment_ProjectItemModification1`
    FOREIGN KEY (`projectItemModificationId`)
    REFERENCES `mydb`.`ProjectItemModification` (`id`)
    ON DELETE CASCADE
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`RelevanceHistory`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`RelevanceHistory` (
  `createdAt` DATE NOT NULL,
  `projectItemType` ENUM('COMMIT', 'ISSUE', 'PULL_REQUEST', 'FILE') NOT NULL,
  `quantity` INT NOT NULL,
  `Project_name` VARCHAR(45) NOT NULL,
  `Project_owner` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`createdAt`, `projectItemType`),
  INDEX `fk_RelevanceHistory_Project1_idx` (`Project_name` ASC, `Project_owner` ASC),
  CONSTRAINT `fk_RelevanceHistory_Project1`
    FOREIGN KEY (`Project_name` , `Project_owner`)
    REFERENCES `mydb`.`Project` (`name` , `owner`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Analysis`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Analysis` (
  `projectName` VARCHAR(45) NOT NULL,
  `projectOwner` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`projectName`, `projectOwner`),
  INDEX `fk_Analysis_Project1_idx` (`projectName` ASC, `projectOwner` ASC),
  CONSTRAINT `fk_Analysis_Project1`
    FOREIGN KEY (`projectName` , `projectOwner`)
    REFERENCES `mydb`.`Project` (`name` , `owner`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`AnalysisHistory`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`AnalysisHistory` (
  `date` VARCHAR(45) NOT NULL,
  `projectName` VARCHAR(45) NOT NULL,
  `projectOwner` VARCHAR(45) NOT NULL,
  `AuthorSetId` INT NOT NULL,
  `numberOfMensions` INT NOT NULL,
  PRIMARY KEY (`date`, `projectName`, `projectOwner`),
  INDEX `fk_AnalysisHistory_Analysis1_idx` (`projectName` ASC, `projectOwner` ASC),
  CONSTRAINT `fk_AnalysisHistory_Analysis1`
    FOREIGN KEY (`projectName` , `projectOwner`)
    REFERENCES `mydb`.`Analysis` (`projectName` , `projectOwner`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`AnalysisParameterValue`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`AnalysisParameterValue` (
  `idAnalysisParameterValue` INT NOT NULL,
  `value` VARCHAR(45) NOT NULL,
  `type` ENUM('TEXT', 'EXTENSIONS') NOT NULL,
  PRIMARY KEY (`idAnalysisParameterValue`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`ModificationDate`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`ModificationDate` (
  `date` DATE NOT NULL,
  `projectItemModificationId` INT NOT NULL,
  PRIMARY KEY (`date`),
  INDEX `fk_ModificationDate_ProjectItemModification1_idx` (`projectItemModificationId` ASC),
  CONSTRAINT `fk_ModificationDate_ProjectItemModification1`
    FOREIGN KEY (`projectItemModificationId`)
    REFERENCES `mydb`.`ProjectItemModification` (`id`)
    ON DELETE CASCADE
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Author`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Author` (
  `name` VARCHAR(45) NOT NULL,
  `setId` INT NOT NULL,
  `AnalysisHistory_date` VARCHAR(45) NOT NULL,
  `AnalysisHistory_projectName` VARCHAR(45) NOT NULL,
  `AnalysisHistory_projectOwner` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`name`),
  INDEX `fk_Author_AnalysisHistory1_idx` (`AnalysisHistory_date` ASC, `AnalysisHistory_projectName` ASC, `AnalysisHistory_projectOwner` ASC),
  CONSTRAINT `fk_Author_AnalysisHistory1`
    FOREIGN KEY (`AnalysisHistory_date` , `AnalysisHistory_projectName` , `AnalysisHistory_projectOwner`)
    REFERENCES `mydb`.`AnalysisHistory` (`date` , `projectName` , `projectOwner`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`AnalysisItem`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`AnalysisItem` (
  `type1` ENUM('COMMIT', 'ISSUE', 'PULL_REQUEST', 'FILE') NOT NULL,
  `type2` ENUM('COMMIT', 'ISSUE', 'PULL_REQUEST', 'FILE') NOT NULL,
  `Analysis_projectName` VARCHAR(45) NOT NULL,
  `Analysis_projectOwner` VARCHAR(45) NOT NULL,
  `value` INT NOT NULL,
  INDEX `fk_AnalysisItem_Analysis1_idx` (`Analysis_projectName` ASC, `Analysis_projectOwner` ASC),
  PRIMARY KEY (`type1`, `type2`),
  CONSTRAINT `fk_AnalysisItem_Analysis1`
    FOREIGN KEY (`Analysis_projectName` , `Analysis_projectOwner`)
    REFERENCES `mydb`.`Analysis` (`projectName` , `projectOwner`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`ProjectItemCorrelation`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`ProjectItemCorrelation` (
  `itemId` VARCHAR(45) NOT NULL,
  `itemProjectName` VARCHAR(45) NOT NULL,
  `itemProjectOwner` VARCHAR(45) NOT NULL,
  `correlatedId` VARCHAR(45) NOT NULL,
  `correlatedProjectName` VARCHAR(45) NOT NULL,
  `correlatedProjectOwner` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`itemId`, `itemProjectName`, `itemProjectOwner`, `correlatedId`, `correlatedProjectName`, `correlatedProjectOwner`),
  INDEX `fk_ProjectItem_has_ProjectItem_ProjectItem2_idx` (`correlatedId` ASC, `correlatedProjectName` ASC, `correlatedProjectOwner` ASC),
  INDEX `fk_ProjectItem_has_ProjectItem_ProjectItem1_idx` (`itemId` ASC, `itemProjectName` ASC, `itemProjectOwner` ASC),
  CONSTRAINT `fk_ProjectItem_has_ProjectItem_ProjectItem1`
    FOREIGN KEY (`itemId` , `itemProjectName` , `itemProjectOwner`)
    REFERENCES `mydb`.`ProjectItem` (`id` , `projectName` , `projectOwner`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ProjectItem_has_ProjectItem_ProjectItem2`
    FOREIGN KEY (`correlatedId` , `correlatedProjectName` , `correlatedProjectOwner`)
    REFERENCES `mydb`.`ProjectItem` (`id` , `projectName` , `projectOwner`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
